#!/usr/bin/env python

"""
****************************************************************************
 treeline.py, the main program file

 TreeLine, an information storage program
 Copyright (C) 2004, Douglas W. Bell

 This is free software; you can redistribute it and/or modify it under the
 terms of the GNU General Public License, Version 2.  This program is
 distributed in the hope that it will be useful, but WITTHOUT ANY WARRANTY.
*****************************************************************************
"""

__progname__ = 'TreeLine'
__version__ = '0.9.0'
__author__ = 'Doug Bell'

helpFilePath = '/usr/local/share/doc/treeline'   # modified by install script

import sys, getopt
import treedoc, cmdline
from cmdline import CmdLine

def main():
    if hasattr(sys, 'setappdefaultencoding'):
        sys.setappdefaultencoding('utf-8')
    elif sys.getdefaultencoding() != 'utf-8':
        print 'Warning: encoding not set for unicode - see ReadMe file'
    if not treedoc.testXmlParser():
        QMessageBox.critical(win, 'Error', \
                             'Error loading XML Parser\n'\
                             'See TreeLine ReadMe file', 1, 0)
        sys.exit(3)
    if not hasattr(getopt, 'gnu_getopt'):  # not in Python < 2.3
        getopt.gnu_getopt = getopt.getopt
    try:
        opts, args = getopt.gnu_getopt(sys.argv[1:], CmdLine.options, \
                                       CmdLine.longOptions)
    except getopt.GetoptError:
        print cmdline.__doc__
        sys.exit(2)

    if opts:
        CmdLine(opts, args)
    else:
        from treemainwin import TreeMainWin
        from qt import QApplication

        app = QApplication(sys.argv)
        win = TreeMainWin()
        app.setMainWidget(win)
        if args:
            win.openFile(args[0])
        else:
            win.autoOpen()
        win.show()
        app.exec_loop()


if __name__ == '__main__':
    main()
